(* #use "topfind";; *)
(* #require "num";; *)
(* #install_printer Q.pp_print;; *)

open Geom_ops

(* let filtre = TODO *)

;;
(* #require "graphics";; *)

let () = Graphics.open_graph " 500x500"

let offset = 200., 200.
let scale = 80

let transform offset v =
  let n = float_of_int (Q.(to_int (v * Q.of_int scale))) in
  int_of_float (offset +. n)

let vertex_position (x, y) =
  let (ox, oy) = offset in
  transform ox x, transform oy y

let draw_line (L ({ x = lx; y = ly }, V(vx, vy))) =
  let open Graphics in
  set_color black;
  let x, y = vertex_position (lx, ly) in
  moveto x y;
  let x', y' = vertex_position Q.(vx + lx, vy + ly) in
  lineto (x') (y');
  fill_circle x y 3

let draw_point ?(col=Graphics.red) ({x; y}) =
  let open Graphics in
  set_color col;
  let x, y = vertex_position (x, y) in
  fill_circle x y 4

let draw_segment (S ({ x = x1; y= y1 }, { x = x2; y = y2 })) =
  let open Graphics in
  let x, y = vertex_position (x1, y1) in
  moveto x y;
  set_color green;
  fill_circle x y 3;
  let x', y' = vertex_position (x2, y2) in
  set_color black;
  lineto (x') (y');
  set_color blue;
  fill_circle x' y' 3

let draw_polygon ?(col=Graphics.red) l =
  let a = Array.of_list (List.map (fun ({ x = vx; y = vy}) -> vertex_position (vx, vy)) l) in
  Graphics.set_color col;
  Graphics.fill_poly a;
  Graphics.set_color Graphics.black;
  Graphics.draw_poly a;
  List.iter (draw_point ~col) l


let p1 = p 0 2
let p2 = p 3 5
let p3 = p 6 2
let p3' = p 3 0
let p4 = p 2 (-1)
let p5 = p 3 3

let poly = [p1;p2;p3;p4;p3';p5]

let poly =
  [p (-1) 0;
   p (-1) 4;
   p 0 4;
   p 0 5;
   p 1 5;
   p 1 3;
   p 2 4;
   p 3 4;
   p 3 3;
   p 4 4;
   p 5 3;
   p 5 5;
   p 6 4;
   p 7 5;
   p 7 0;
  ]

let line = L(p (-2) 4, v (5) (0))
(* let line = L(p (-2) (-1), v (5) (0)) *)
(* let line = L(p (-2) 7, v (5) (0)) *)


(* let p1, p2 = coupe_poly poly line *)

(* let s, f1, r = coupe_un_polygone poly line *)
(* let s, f2, r = coupe_un_polygone r line *)

let poly_add, gauche, droite =
  let dll = to_dll poly in
  let gauche, droite = rajoute_les_points_sur_la_ligne line dll in
  to_list dll,
  gauche,
  droite

let sgauche, sdroite =
  List.map (fun v -> v.contents) gauche,
  List.map (fun v -> v.contents) droite

(* let polyd = to_dll poly_add *)
(* let pd1, pd2, pd3, pd4 = *)
(*   match droite with *)
(*   | p1 :: p2 :: p3 :: p4 :: _ -> p1, p2, p3, p4 *)
(*   | _ -> assert false *)
(* let poly_add' = to_list @@ shortcut pd1 pd2 *)

let poly_gauche, poly_droite = coupe_poly line poly

(* let poly_add' = *)
(*   to_list @@ List.hd (shortcuts line droite) *)

(* let poly_add' = *)
(*   to_list @@ List.hd (List.tl (List.tl (shortcuts line (List.rev gauche)))) *)


let () =
  let open Graphics in
  clear_graph ();
  (* let line = (L (p 0 3, v 4 (-2))) in *)
(*
  let line = (L (p 4 1, v (-4) (2))) in
  let point = (p 0 1) in
  let p2 = (p 2 3) in
  let segment = (S (point, p2)) in
  draw_line line;
  draw_segment segment;
  List.iter draw_segment (plie_segment segment line);
*)

  draw_polygon ~col:yellow poly;
  (* draw_polygon ~col:red f1; *)
  (* draw_polygon ~col:red poly_add; *)
  (* draw_polygon ~col:red poly_add'; *)
  List.iter (draw_polygon ~col:green) poly_gauche;
  List.iter (draw_polygon ~col:cyan) poly_droite;
  List.iter (draw_point ~col:blue) sgauche;
  List.iter (draw_point ~col:blue) sdroite;
  (* draw_polygon ~col:red r; *)
  draw_line line;
  (* wait (); *)

  (* clear_graph (); *)
  (* List.iter (draw_polygon ~col:green) p1; *)
  (* List.iter (draw_polygon ~col:magenta) p2; *)

  (* (\* draw_polygon poly; *\) *)
  (* draw_line line; *)
  (* (\* List.iter (draw_point ~col:blue) pre; *\) *)
  (* (\* List.iter (draw_point ~col:red) endd; *\) *)
  (* wait (); *)
  ()


let rec wait () =
  let { Graphics.key; Graphics.keypressed } = Graphics.(wait_next_event [ Key_pressed ]) in
  if keypressed && key = 'q' then ()
  else wait ()

let () = wait ()
