open Core.Std

type solution = {mapping: Geom_ops.mapping; facets: int list list}
                [@@ deriving sexp]

val solution_string : solution -> string
val check:
  ?verbose:unit -> solution -> bool
(* val resemblance: Icfp_parse.problem -> solution -> float option *)

val solution_size : solution -> int

type mk_solution

val empty_solution: mk_solution
val add_facets: (Geom_ops.vertex * Geom_ops.vertex) list -> mk_solution -> mk_solution
val get_solution: mk_solution -> solution

val get_destination_facets: solution -> Geom_ops.vertex list list

val compute_resemblance: Geom_ops.vertex list list -> solution -> float Or_error.t

val renormalize_solution : solution -> solution
