open Core.Std

let probleme_name = Sys.argv.(1)
let problem = Icfp_parse.parse (In_channel.read_all probleme_name)


type stuff =
  | Up
  | Down
  | Quit

let args = [
  'q', ("quit", Quit);
  'f', ("fold", Up);
  'u', ("unfold", Down);
]

let () = Show.init ()
let solution =
  let () = Show.wait problem "probleme" ['q', ("quit", ())] in
  let rec loop folds =
    let res, hist = Convex_solver.launch_and_replace problem folds in
    let pro = Pliage.to_probleme res in
    let sol = Pliage.to_solution res in
    (* Format.printf "cuts:@ %a@." *)
    (*   (Format.pp_print_list ~pp_sep:(Format.pp_print_space) Geom_ops.pp_ligne) *)
    (*   hist; *)
    Format.printf "sol:@ %a@." Pliage.pp_pliage res;
    let sol = Solution.renormalize_solution sol in
    ignore(Solution.check ~verbose:() sol:bool);
    match Show.wait_solution_et_probleme sol pro "convexe" args with
    | Quit -> sol
    | Up ->
      loop (folds + 1)
    | Down ->
      loop (max 0 (folds - 1))
  in
  loop 0

let () =
  ignore(Solution.check ~verbose:() solution:bool);
  print_newline ();
  print_endline (Solution.solution_string solution)
