(* let chose = *)
(*   let open Geom_ops in *)
(*   let ligne = *)
(*     let a = Q.of_string "113/256" in *)
(*     let b = Q.of_string "-3/64" in *)
(*     let c = Q.of_string "-55/512" in *)
(*     let d = Q.of_string "83/256" in *)
(*     let p = {x = a; y = b} in *)
(*     let q = {x = c; y = d} in *)
(*     (\* let p, q = q, p in *\) *)
(*     L(p, q -= p) *)
(*   in *)
(*   let s1 = Pliage.plie ligne Pliage.carre in *)
(*   let s2 = Pliage.plie l2 s1 in *)
(*   (\* Pliage.plie l3 s1 *\) *)
(*   s2 *)

let chose = Pliage.carre

let prev_state = ref []
let state = ref chose
let sol = ref (Pliage.to_solution !state)
let prob = ref (Pliage.to_probleme !state)

let pp_vertex ppf {Geom_ops.x; y} =
  Format.fprintf ppf "{ %a; %a }" Q.pp_print x Q.pp_print y

let update s =
  state := s;
  sol := Pliage.to_solution s;
  prob := Pliage.to_probleme s;
  ignore (Solution.check ~verbose:() !sol);
  (* (print_endline (Solution.solution_string !sol); *)
  (*  print_newline ()) *)
  ()

let push s =
  prev_state := !state :: !prev_state;
  update s

let undo () =
  match !prev_state with
  | [] -> ()
  | h :: t ->
    prev_state := t;
    update h

let round_q n p =
  Q.make
    (Z.of_int (n * (Z.to_int p.Q.num / n)))
    p.Q.den
    (* (Z.of_int (max 1 (Z.to_int p.Q.den / n))) *)

let round_vert n v =
  { Geom_ops.x = round_q n v.Geom_ops.x;
    y = round_q n v.y }

let do_stuff p1' p2' =
  let p1 = round_vert 4 p1' in
  let p2 = round_vert 4 p2' in
  let ligne = Geom_ops.(L(p1, p2 -= p1)) in
  let s' = Pliage.plie ligne !state in
  push s';
  Format.printf "plop %a %a =>@ %a %a@."
    pp_vertex p1' pp_vertex p2'
    pp_vertex p1 pp_vertex p2

let () =
  let () = Show.init () in
  try
    Show.interract sol prob do_stuff "DEMO"
      [ 'q', ("quit", fun () -> raise Exit);
        'r', ("reset", fun () -> update Pliage.carre);
        'u', ("undo", undo) ]
  with _ ->
    print_newline ();
    print_newline ();
    print_endline (Solution.solution_string !sol);
    print_newline ()


